%
% MALLA DE HEXAEDROS PARA UN CUBO DE LADO UNITARIO
%


clear;
hold off;

%Definicion de variables%

syms('NUMx','NUMy','NUMz','CUBO','ARISTA','PUNTO','X','Y','Z');
syms('X0','Y0','Z0','A','B','C','D','s','NUMarista');
syms('u','v','w','EXISTEarista','EXISTEnodo','deltaX','deltaY','deltaZ');
syms('COLUMNAarista','pos1','pos2','i','j','k','m','h','p','q','numD','NUMnodo','auxiliar','r');
syms('NumPuntosx','NumPuntosy','NumPuntosz','SUMA','hnivel','hprevio','nivel','h1')

%Vectores de movimiento%

u=[0 0 1 1 0 0 1 1];
v=[0 1 1 0 0 1 1 0];
w=[0 0 0 0 1 1 1 1];

CUBO=0;
PUNTO=1;
ARISTA=1;

%ENTRADA DE DATOS%

fprintf(1,'Programa de la malla hexaedrica.\n');

%Eleccion de la estrategia de espaciado vertical%

FLAG=0;
while (FLAG<1)|(FLAG>7)
 fprintf(1,'Elija la estrategia de espaciado vertical\n');
 fprintf(1,'1. Incremento constante\n');
 fprintf(1,'2. Incremento lineal\n');
 fprintf(1,'3. Incremento cuadratico\n');
 fprintf(1,'4. Incremento cubico\n');
 fprintf(1,'5. Progresion aritmetica\n');
 fprintf(1,'6. Progresion geometrica\n');
 fprintf(1,'7. Concentracion en la zona inferior manteniendo esquemas de segundo orden\n');
 fprintf(1,'Escriba 1,2,3,4,5,6 o 7.\n');
 FLAG = input(' ');
 if (FLAG<1)|(FLAG>7)
     fprintf(1,'\n\nPor favor introduzca un numero comprendido entre 1 y 7\n\n\n');
 end;
end;

%ESTRATEGIA 1%
if FLAG==1

%Introduccion de datos%

fprintf(1,'\nHa seleccionado la ESTRATEGIA 1\n\n');    
fprintf(1,'Introduzca el numero de puntos en la direccion x\n');
NumPuntosx = input(' ');
fprintf(1,'Introduzca el numero de puntos en la direccion y\n');
NumPuntosy = input(' ');
fprintf(1,'Introduzca el numero de puntos en la direccion z\n');
NumPuntosz = input(' ');

NUMz=NumPuntosz-1;
NUMy=NumPuntosy-1;
NUMx=NumPuntosx-1;
deltaX=1/NUMx;
deltaY=1/NUMy;
deltaZ=1/NUMz;

%Bucle de generacion de hexaedros%

for k=1:NUMz
    
    Z0=(k-1)*deltaZ;
    
	for j=1:NUMy
		Y0=(j-1)*deltaY;
		
		for i=1:NUMx
			X0=(i-1)*deltaX;
			CUBO=CUBO+1;

			for r=1:8
			C(r)=0;
			end;

			for h=1:8
				
				X=X0+u(h)*deltaX;
				Y=Y0+v(h)*deltaY;
				Z=Z0+w(h)*deltaZ;
				
				EXISTEnodo=0;
				p=1;

				while p<PUNTO & EXISTEnodo==0

					if coordX(p)==X & coordY(p)==Y & coordZ(p)==Z
						
						EXISTEnodo=1;
						NUMnodo=p;
					else
						
						p=p+1;
					end;
				end;
				
				if EXISTEnodo==1
					C(h)=NUMnodo;
				else
					coordX(PUNTO)=X;
					coordY(PUNTO)=Y;
					coordZ(PUNTO)=Z;
					C(h)=PUNTO;
					PUNTO=PUNTO+1;
				end;
			end;

               
            for q=1:8
                
                D(CUBO,q)=C(q);
                
            end;
            
%Creacin de aristas

			for COLUMNAarista=1:12
				
				pos1=COLUMNAarista;
				pos2=COLUMNAarista+1;
				
				if pos2==5
					pos2=1;
				end;
				
				if pos2==9
					pos2=5;
				end;
				
				if COLUMNAarista>8
					pos1=COLUMNAarista-8;
					pos2=pos1+4;
				end;
                    
                    a=double(C(pos1));
                    b=double(C(pos2));
                    
				if a > b
					auxiliar=pos1;
					pos1=pos2;
					pos2=auxiliar;
				end;
                
                a=C(pos1);
                b=C(pos2);

				EXISTEarista=0;
				s=1;
				
				while s<ARISTA & EXISTEarista==0

					if B(1,s)==C(pos1) & B(2,s)==C(pos2)

						EXISTEarista=1;
						NUMarista=s;
					else
						s=s+1;
					end;
				end;
				
				if EXISTEarista==1
					A(CUBO,COLUMNAarista)=NUMarista;
					
				else
					A(CUBO,COLUMNAarista)=ARISTA;
					B(1,ARISTA)=C(pos1);
                    B(2,ARISTA)=C(pos2);
                    
                    UNO=subs(a);
                    DOS=subs(b);
                    
                    %Dibujar cada arista en el momento que se crea%
                    DibujarX(1)=coordX(UNO);
                    DibujarX(2)=coordX(DOS);
                    DibujarY(1)=coordY(UNO);
                    DibujarY(2)=coordY(DOS);
                    DibujarZ(1)=coordZ(UNO);
                    DibujarZ(2)=coordZ(DOS);
                   
                    plot3(DibujarX,DibujarY,DibujarZ);
                    hold on;
                                       
					ARISTA=ARISTA+1;
				end;
			end;

		end;
	end;
end;


%CREACION DEL FICHERO CON TODAS LAS RELACIONES ENTRE NODOS,ARISTAS Y CUBOS%

 fprintf(1,'Escriba el nombre del fichero de la forma - disco:\\nombre.ext\n');
 fprintf(1,'Por ejemplo:  A:\\OUTPUT.DTA\n');
 NAME = input(' ','s');
 OUP = fopen(NAME,'wt');
 fprintf(OUP, 'MALLA HEXAEDRICA - Incremento constante\n\n');
 %Matriz A%
 fprintf(OUP, 'Matriz A relaciona cada CUBO con el nombre de sus 12 ARISTAS \n\n');
 fprintf(OUP, 'CUBO  ARISTAS\n\n');
 for I = 1 : CUBO 
 fprintf(OUP, ' %3d  ', I);
 for J = 1 : 12 
 fprintf(OUP, '  %3d', subs(A(I,J)));
 end;
 fprintf(OUP, '\n');
 end;
 
 fprintf(OUP, '\n\n\n');
 
 %Matriz D%
 fprintf(OUP, 'Matriz D relaciona cada CUBO con el nombre de sus 8 NODOS \n\n');
 fprintf(OUP, 'CUBO  NODOS\n\n');
 for I = 1 : CUBO 
 fprintf(OUP, ' %3d  ', I);
 for J = 1 : 8 
 fprintf(OUP, '  %3d', subs(D(I,J)));
 end;
 fprintf(OUP, '\n');
 end;
 
 fprintf(OUP, '\n\n\n');
 
 %Matriz B%
 fprintf(OUP, 'Matriz B relaciona cada ARISTA con el nombre de sus 2 NODOS \n\n');
 fprintf(OUP, 'ARISTA  NODOS\n\n');
 for I = 1 :  (ARISTA-1)
 fprintf(OUP, ' %3d  ', I);
 for J = 1 : 2 
 fprintf(OUP, '  %3d', subs(B(J,I)));
 end;
 fprintf(OUP, '\n');
 end;
 
 fprintf(OUP, '\n\n\n');
 
 %Vectores de coordenadas%
 fprintf(OUP, 'Relacion de cada NODO con el valor de sus 3 COORDENADAS \n\n');
 fprintf(OUP, 'NODO    COORD X        COORD Y        COORD Z\n\n');
 for I = 1 :  (PUNTO-1)
 fprintf(OUP, ' %3d  ', I);
  
 fprintf(OUP, '%12.8f   %12.8f   %12.8f', coordX(I),coordY(I),coordZ(I));
 
 fprintf(OUP, '\n');
 end;
 
 fclose(OUP);
   
end;

%ESTRATEGIA 2%
if FLAG==2

%Introduccion de datos%    
    
fprintf(1,'\nHa seleccionado la ESTRATEGIA 2\n\n'); 
fprintf(1,'Introduzca el numero de puntos en la direccion x\n');
NumPuntosx = input(' ');
fprintf(1,'Introduzca el numero de puntos en la direccion y\n');
NumPuntosy = input(' ');
fprintf(1,'Introduzca el numero de puntos en la direccion z\n');
NumPuntosz = input(' ');

NUMz=NumPuntosz-1;
NUMy=NumPuntosy-1;
NUMx=NumPuntosx-1;
deltaX=1/NUMx;
deltaY=1/NUMy;

SUMA=2;
h1=(1/NUMz);

%Bucle de eleccion de incremento vertical inicial%

while abs(SUMA-1)>1e-6
    
    if (SUMA-1)>0
        h1=0.999*h1;
    else
        h1=1.001*h1;
    end;
        
    hprevio=h1;  
    SUMA=h1;
    
    %Bucle de calculo de incremento%
    
    for nivel=2:NUMz
        
        hnivel=hprevio*h1;
        SUMA=SUMA+hnivel;
        hprevio=hnivel;
    end;
end;
    
    hnivel=h1;

    %Bucle de generacion de hexaedros%
    
for k=1:NUMz
    
    if k==1
        Z0=0;
        deltaZ=h1;
    else
    
	Z0=Z0+hnivel;
    hnivel=hnivel*h1;
    deltaZ=hnivel;
    end;
    
	for j=1:NUMy
		Y0=(j-1)*deltaY;
		
		for i=1:NUMx
			X0=(i-1)*deltaX;
			CUBO=CUBO+1;

			for r=1:8
			C(r)=0;
			end;

			for h=1:8
				
				X=X0+u(h)*deltaX;
				Y=Y0+v(h)*deltaY;
				Z=Z0+w(h)*deltaZ;
				
				EXISTEnodo=0;
				p=1;

				while p<PUNTO & EXISTEnodo==0

					if coordX(p)==X & coordY(p)==Y & coordZ(p)==Z
						
						EXISTEnodo=1;
						NUMnodo=p;
					else
						
						p=p+1;
					end;
				end;
				
				if EXISTEnodo==1
					C(h)=NUMnodo;
				else
					coordX(PUNTO)=X;
					coordY(PUNTO)=Y;
					coordZ(PUNTO)=Z;
					C(h)=PUNTO;
					PUNTO=PUNTO+1;
				end;
			end;

               
            for q=1:8
                
                D(CUBO,q)=C(q);
                
            end;
            
%Creacin de aristas

			for COLUMNAarista=1:12
				
				pos1=COLUMNAarista;
				pos2=COLUMNAarista+1;
				
				if pos2==5
					pos2=1;
				end;
				
				if pos2==9
					pos2=5;
				end;
				
				if COLUMNAarista>8
					pos1=COLUMNAarista-8;
					pos2=pos1+4;
				end;
                    
                    a=double(C(pos1));
                    b=double(C(pos2));
                    
				if a > b
					auxiliar=pos1;
					pos1=pos2;
					pos2=auxiliar;
				end;
                
                a=C(pos1);
                b=C(pos2);

				EXISTEarista=0;
				s=1;
				
				while s<ARISTA & EXISTEarista==0

					if B(1,s)==C(pos1) & B(2,s)==C(pos2)

						EXISTEarista=1;
						NUMarista=s;
					else
						s=s+1;
					end;
				end;
				
				if EXISTEarista==1
					A(CUBO,COLUMNAarista)=NUMarista;
					
				else
					A(CUBO,COLUMNAarista)=ARISTA;
					B(1,ARISTA)=C(pos1);
                    B(2,ARISTA)=C(pos2);
                    
                    UNO=subs(a);
                    DOS=subs(b);
                    
                    %Dibujar cada arista en el momento que se crea%
                    DibujarX(1)=coordX(UNO);
                    DibujarX(2)=coordX(DOS);
                    DibujarY(1)=coordY(UNO);
                    DibujarY(2)=coordY(DOS);
                    DibujarZ(1)=coordZ(UNO);
                    DibujarZ(2)=coordZ(DOS);
                   
                    plot3(DibujarX,DibujarY,DibujarZ);
                    hold on;
                                       
					ARISTA=ARISTA+1;
				end;
			end;

		end;
	end;
end;


%CREACION DEL FICHERO CON TODAS LAS RELACIONES ENTRE NODOS,ARISTAS Y CUBOS%

 fprintf(1,'Escriba el nombre del fichero de la forma - disco:\\nombre.ext\n');
 fprintf(1,'Por ejemplo:  A:\\OUTPUT.DTA\n');
 NAME = input(' ','s');
 OUP = fopen(NAME,'wt');
 fprintf(OUP, 'MALLA HEXAEDRICA - Incremento lineal\n\n');
 %Matriz A%
 fprintf(OUP, 'Matriz A relaciona cada CUBO con el nombre de sus 12 ARISTAS \n\n');
 fprintf(OUP, 'CUBO  ARISTAS\n\n');
 for I = 1 : CUBO 
 fprintf(OUP, ' %3d  ', I);
 for J = 1 : 12 
 fprintf(OUP, '  %3d', subs(A(I,J)));
 end;
 fprintf(OUP, '\n');
 end;
 
 fprintf(OUP, '\n\n\n');
 
 %Matriz D%
 fprintf(OUP, 'Matriz D relaciona cada CUBO con el nombre de sus 8 NODOS \n\n');
 fprintf(OUP, 'CUBO  NODOS\n\n');
 for I = 1 : CUBO 
 fprintf(OUP, ' %3d  ', I);
 for J = 1 : 8 
 fprintf(OUP, '  %3d', subs(D(I,J)));
 end;
 fprintf(OUP, '\n');
 end;
 
 fprintf(OUP, '\n\n\n');
 
 %Matriz B%
 fprintf(OUP, 'Matriz B relaciona cada ARISTA con el nombre de sus 2 NODOS \n\n');
 fprintf(OUP, 'ARISTA  NODOS\n\n');
 for I = 1 :  (ARISTA-1)
 fprintf(OUP, ' %3d  ', I);
 for J = 1 : 2 
 fprintf(OUP, '  %3d', subs(B(J,I)));
 end;
 fprintf(OUP, '\n');
 end;
 
 fprintf(OUP, '\n\n\n');
 
 %Vectores de coordenadas%
 fprintf(OUP, 'Relacion de cada NODO con el valor de sus 3 COORDENADAS \n\n');
 fprintf(OUP, 'NODO    COORD X        COORD Y        COORD Z\n\n');
 for I = 1 :  (PUNTO-1)
 fprintf(OUP, ' %3d  ', I);
  
 fprintf(OUP, '%12.8f   %12.8f   %12.8f', coordX(I),coordY(I),coordZ(I));
 
 fprintf(OUP, '\n');
 end;
 
 fclose(OUP);
    
    
    
end;

%ESTRATEGIA 3%
if FLAG==3
    
%Introduccion de datos%    

    
fprintf(1,'\nHa seleccionado la ESTRATEGIA 3\n\n'); 
fprintf(1,'Introduzca el numero de puntos en la direccion x\n');
NumPuntosx = input(' ');
fprintf(1,'Introduzca el numero de puntos en la direccion y\n');
NumPuntosy = input(' ');
fprintf(1,'Introduzca el numero de puntos en la direccion z\n');
NumPuntosz = input(' ');

NUMz=NumPuntosz-1;
NUMy=NumPuntosy-1;
NUMx=NumPuntosx-1;
deltaX=1/NUMx;
deltaY=1/NUMy;

SUMA=2;
h1=(1/NUMz);

%Bucle de eleccion de incremento vertical inicial%

while abs(SUMA-1)>1e-6
    
    if (SUMA-1)>0
        h1=0.999*h1;
    else
        h1=1.001*h1;
    end;
        
    hprevio=h1;  
    SUMA=h1;
    
    %Bucle de calculo de incremento%
    
    for nivel=2:NUMz
        
        hnivel=h1*hprevio^2;
        SUMA=SUMA+hnivel;
        hprevio=hnivel;
    end;
end;
    
    hnivel=h1;

    %Bucle de generacion de hexaedros%
    
for k=1:NUMz
    
    if k==1
        Z0=0;
        deltaZ=h1;
    else
    
	Z0=Z0+hnivel;
    hnivel=h1*hnivel^2;
    deltaZ=hnivel;
    end;
    
	for j=1:NUMy
		Y0=(j-1)*deltaY;
		
		for i=1:NUMx
			X0=(i-1)*deltaX;
			CUBO=CUBO+1;

			for r=1:8
			C(r)=0;
			end;

			for h=1:8
				
				X=X0+u(h)*deltaX;
				Y=Y0+v(h)*deltaY;
				Z=Z0+w(h)*deltaZ;
				
				EXISTEnodo=0;
				p=1;

				while p<PUNTO & EXISTEnodo==0

					if coordX(p)==X & coordY(p)==Y & coordZ(p)==Z
						
						EXISTEnodo=1;
						NUMnodo=p;
					else
						
						p=p+1;
					end;
				end;
				
				if EXISTEnodo==1
					C(h)=NUMnodo;
				else
					coordX(PUNTO)=X;
					coordY(PUNTO)=Y;
					coordZ(PUNTO)=Z;
					C(h)=PUNTO;
					PUNTO=PUNTO+1;
				end;
			end;

               
            for q=1:8
                
                D(CUBO,q)=C(q);
                
            end;
            
%Creacin de aristas

			for COLUMNAarista=1:12
				
				pos1=COLUMNAarista;
				pos2=COLUMNAarista+1;
				
				if pos2==5
					pos2=1;
				end;
				
				if pos2==9
					pos2=5;
				end;
				
				if COLUMNAarista>8
					pos1=COLUMNAarista-8;
					pos2=pos1+4;
				end;
                    
                    a=double(C(pos1));
                    b=double(C(pos2));
                    
				if a > b
					auxiliar=pos1;
					pos1=pos2;
					pos2=auxiliar;
				end;
                
                a=C(pos1);
                b=C(pos2);

				EXISTEarista=0;
				s=1;
				
				while s<ARISTA & EXISTEarista==0

					if B(1,s)==C(pos1) & B(2,s)==C(pos2)

						EXISTEarista=1;
						NUMarista=s;
					else
						s=s+1;
					end;
				end;
				
				if EXISTEarista==1
					A(CUBO,COLUMNAarista)=NUMarista;
					
				else
					A(CUBO,COLUMNAarista)=ARISTA;
					B(1,ARISTA)=C(pos1);
                    B(2,ARISTA)=C(pos2);
                    
                    UNO=subs(a);
                    DOS=subs(b);
                    
                    %Dibujar cada arista en el momento que se crea%
                    DibujarX(1)=coordX(UNO);
                    DibujarX(2)=coordX(DOS);
                    DibujarY(1)=coordY(UNO);
                    DibujarY(2)=coordY(DOS);
                    DibujarZ(1)=coordZ(UNO);
                    DibujarZ(2)=coordZ(DOS);
                   
                    plot3(DibujarX,DibujarY,DibujarZ);
                    hold on;
                                       
					ARISTA=ARISTA+1;
				end;
			end;

		end;
	end;
end;


%CREACION DEL FICHERO CON TODAS LAS RELACIONES ENTRE NODOS,ARISTAS Y CUBOS%

 fprintf(1,'Escriba el nombre del fichero de la forma - disco:\\nombre.ext\n');
 fprintf(1,'Por ejemplo:  A:\\OUTPUT.DTA\n');
 NAME = input(' ','s');
 OUP = fopen(NAME,'wt');
 fprintf(OUP, 'MALLA HEXAEDRICA - Incremento cuadratico\n\n');
 %Matriz A%
 fprintf(OUP, 'Matriz A relaciona cada CUBO con el nombre de sus 12 ARISTAS \n\n');
 fprintf(OUP, 'CUBO  ARISTAS\n\n');
 for I = 1 : CUBO 
 fprintf(OUP, ' %3d  ', I);
 for J = 1 : 12 
 fprintf(OUP, '  %3d', subs(A(I,J)));
 end;
 fprintf(OUP, '\n');
 end;
 
 fprintf(OUP, '\n\n\n');
 
 %Matriz D%
 fprintf(OUP, 'Matriz D relaciona cada CUBO con el nombre de sus 8 NODOS \n\n');
 fprintf(OUP, 'CUBO  NODOS\n\n');
 for I = 1 : CUBO 
 fprintf(OUP, ' %3d  ', I);
 for J = 1 : 8 
 fprintf(OUP, '  %3d', subs(D(I,J)));
 end;
 fprintf(OUP, '\n');
 end;
 
 fprintf(OUP, '\n\n\n');
 
 %Matriz B%
 fprintf(OUP, 'Matriz B relaciona cada ARISTA con el nombre de sus 2 NODOS \n\n');
 fprintf(OUP, 'ARISTA  NODOS\n\n');
 for I = 1 :  (ARISTA-1)
 fprintf(OUP, ' %3d  ', I);
 for J = 1 : 2 
 fprintf(OUP, '  %3d', subs(B(J,I)));
 end;
 fprintf(OUP, '\n');
 end;
 
 fprintf(OUP, '\n\n\n');
 
 %Vectores de coordenadas%
 fprintf(OUP, 'Relacion de cada NODO con el valor de sus 3 COORDENADAS \n\n');
 fprintf(OUP, 'NODO    COORD X        COORD Y        COORD Z\n\n');
 for I = 1 :  (PUNTO-1)
 fprintf(OUP, ' %3d  ', I);
  
 fprintf(OUP, '%12.8f   %12.8f   %12.8f', coordX(I),coordY(I),coordZ(I));
 
 fprintf(OUP, '\n');
 end;
 
 fclose(OUP);    
    
end;

%ESTRATEGIA 4%
if FLAG==4

%Introduccion de datos%    
    
fprintf(1,'\nHa seleccionado la ESTRATEGIA 4\n\n'); 
fprintf(1,'Introduzca el numero de puntos en la direccion x\n');
NumPuntosx = input(' ');
fprintf(1,'Introduzca el numero de puntos en la direccion y\n');
NumPuntosy = input(' ');
fprintf(1,'Introduzca el numero de puntos en la direccion z\n');
NumPuntosz = input(' ');

NUMz=NumPuntosz-1;
NUMy=NumPuntosy-1;
NUMx=NumPuntosx-1;
deltaX=1/NUMx;
deltaY=1/NUMy;

SUMA=2;
h1=(1/NUMz);

%Bucle de eleccion de incremento vertical inicial%

while abs(SUMA-1)>1e-6
    
    if (SUMA-1)>0
        h1=0.999*h1;
    else
        h1=1.001*h1;
    end;
        
    hprevio=h1;  
    SUMA=h1;
    
    %Bucle de calculo del incremento%
    
    for nivel=2:NUMz
        
        hnivel=h1*hprevio^3;
        SUMA=SUMA+hnivel;
        hprevio=hnivel;
    end;
end;
    
    hnivel=h1;

    %Bucle de generacion de hexaedros%
    
for k=1:NUMz
    
    if k==1
        Z0=0;
        deltaZ=h1;
    else
    
	Z0=Z0+hnivel;
    hnivel=h1*hnivel^3;
    deltaZ=hnivel;
    end;
    
	for j=1:NUMy
		Y0=(j-1)*deltaY;
		
		for i=1:NUMx
			X0=(i-1)*deltaX;
			CUBO=CUBO+1;

			for r=1:8
			C(r)=0;
			end;

			for h=1:8
				
				X=X0+u(h)*deltaX;
				Y=Y0+v(h)*deltaY;
				Z=Z0+w(h)*deltaZ;
				
				EXISTEnodo=0;
				p=1;

				while p<PUNTO & EXISTEnodo==0

					if coordX(p)==X & coordY(p)==Y & coordZ(p)==Z
						
						EXISTEnodo=1;
						NUMnodo=p;
					else
						
						p=p+1;
					end;
				end;
				
				if EXISTEnodo==1
					C(h)=NUMnodo;
				else
					coordX(PUNTO)=X;
					coordY(PUNTO)=Y;
					coordZ(PUNTO)=Z;
					C(h)=PUNTO;
					PUNTO=PUNTO+1;
				end;
			end;

               
            for q=1:8
                
                D(CUBO,q)=C(q);
                
            end;
            
%Creacin de aristas

			for COLUMNAarista=1:12
				
				pos1=COLUMNAarista;
				pos2=COLUMNAarista+1;
				
				if pos2==5
					pos2=1;
				end;
				
				if pos2==9
					pos2=5;
				end;
				
				if COLUMNAarista>8
					pos1=COLUMNAarista-8;
					pos2=pos1+4;
				end;
                    
                    a=double(C(pos1));
                    b=double(C(pos2));
                    
				if a > b
					auxiliar=pos1;
					pos1=pos2;
					pos2=auxiliar;
				end;
                
                a=C(pos1);
                b=C(pos2);

				EXISTEarista=0;
				s=1;
				
				while s<ARISTA & EXISTEarista==0

					if B(1,s)==C(pos1) & B(2,s)==C(pos2)

						EXISTEarista=1;
						NUMarista=s;
					else
						s=s+1;
					end;
				end;
				
				if EXISTEarista==1
					A(CUBO,COLUMNAarista)=NUMarista;
					
				else
					A(CUBO,COLUMNAarista)=ARISTA;
					B(1,ARISTA)=C(pos1);
                    B(2,ARISTA)=C(pos2);
                    
                    UNO=subs(a);
                    DOS=subs(b);
                    
                    %Dibujar cada arista en el momento que se crea%
                    DibujarX(1)=coordX(UNO);
                    DibujarX(2)=coordX(DOS);
                    DibujarY(1)=coordY(UNO);
                    DibujarY(2)=coordY(DOS);
                    DibujarZ(1)=coordZ(UNO);
                    DibujarZ(2)=coordZ(DOS);
                   
                    plot3(DibujarX,DibujarY,DibujarZ);
                    hold on;
                                       
					ARISTA=ARISTA+1;
				end;
			end;

		end;
	end;
end;


%CREACION DEL FICHERO CON TODAS LAS RELACIONES ENTRE NODOS,ARISTAS Y CUBOS%

 fprintf(1,'Escriba el nombre del fichero de la forma - disco:\\nombre.ext\n');
 fprintf(1,'Por ejemplo:  A:\\OUTPUT.DTA\n');
 NAME = input(' ','s');
 OUP = fopen(NAME,'wt');
 fprintf(OUP, 'MALLA HEXAEDRICA - Incremento cubico\n\n');
 %Matriz A%
 fprintf(OUP, 'Matriz A relaciona cada CUBO con el nombre de sus 12 ARISTAS \n\n');
 fprintf(OUP, 'CUBO  ARISTAS\n\n');
 for I = 1 : CUBO 
 fprintf(OUP, ' %3d  ', I);
 for J = 1 : 12 
 fprintf(OUP, '  %3d', subs(A(I,J)));
 end;
 fprintf(OUP, '\n');
 end;
 
 fprintf(OUP, '\n\n\n');
 
 %Matriz D%
 fprintf(OUP, 'Matriz D relaciona cada CUBO con el nombre de sus 8 NODOS \n\n');
 fprintf(OUP, 'CUBO  NODOS\n\n');
 for I = 1 : CUBO 
 fprintf(OUP, ' %3d  ', I);
 for J = 1 : 8 
 fprintf(OUP, '  %3d', subs(D(I,J)));
 end;
 fprintf(OUP, '\n');
 end;
 
 fprintf(OUP, '\n\n\n');
 
 %Matriz B%
 fprintf(OUP, 'Matriz B relaciona cada ARISTA con el nombre de sus 2 NODOS \n\n');
 fprintf(OUP, 'ARISTA  NODOS\n\n');
 for I = 1 :  (ARISTA-1)
 fprintf(OUP, ' %3d  ', I);
 for J = 1 : 2 
 fprintf(OUP, '  %3d', subs(B(J,I)));
 end;
 fprintf(OUP, '\n');
 end;
 
 fprintf(OUP, '\n\n\n');
 
 %Vectores de coordenadas%
 fprintf(OUP, 'Relacion de cada NODO con el valor de sus 3 COORDENADAS \n\n');
 fprintf(OUP, 'NODO    COORD X        COORD Y        COORD Z\n\n');
 for I = 1 :  (PUNTO-1)
 fprintf(OUP, ' %3d  ', I);
  
 fprintf(OUP, '%12.8f   %12.8f   %12.8f', coordX(I),coordY(I),coordZ(I));
 
 fprintf(OUP, '\n');
 end;
 
 fclose(OUP);
    
end;

%ESTRATEGIA 5%
if FLAG==5
   
    %Introduccion de datos%
    
    fprintf(1,'\nHa seleccionado la ESTRATEGIA 5\n\n'); 
fprintf(1,'Introduzca el numero de puntos en la direccion x\n');
NumPuntosx = input(' ');
fprintf(1,'Introduzca el numero de puntos en la direccion y\n');
NumPuntosy = input(' ');
fprintf(1,'Introduzca el numero de puntos en la direccion z\n');
NumPuntosz = input(' ');

NUMz=NumPuntosz-1;
NUMy=NumPuntosy-1;
NUMx=NumPuntosx-1;
deltaX=1/NUMx;
deltaY=1/NUMy;

SUMA=2;
h1=(1/NUMz);

%Bucle de eleccion de incremento vertical inicial%

while abs(SUMA-1)>1e-6
    
    if (SUMA-1)>0
        h1=0.999*h1;
    else
        h1=1.001*h1;
    end;
        
    hprevio=h1;  
    SUMA=h1;
    
    %Bucle de calculo del incremento%
    
    for nivel=2:NUMz
        
        hnivel=hprevio+h1^2;
        SUMA=SUMA+hnivel;
        hprevio=hnivel;
    end;
end;
    
    hnivel=h1;

    %Bucle de generacion de hexaedros% 
    
for k=1:NUMz
    
    if k==1
        Z0=0;
        deltaZ=h1;
    else
    
	Z0=Z0+hnivel;
    hnivel=hnivel+h1^2;
    deltaZ=hnivel;
    end;
    
	for j=1:NUMy
		Y0=(j-1)*deltaY;
		
		for i=1:NUMx
			X0=(i-1)*deltaX;
			CUBO=CUBO+1;

			for r=1:8
			C(r)=0;
			end;

			for h=1:8
				
				X=X0+u(h)*deltaX;
				Y=Y0+v(h)*deltaY;
				Z=Z0+w(h)*deltaZ;
				
				EXISTEnodo=0;
				p=1;

				while p<PUNTO & EXISTEnodo==0

					if coordX(p)==X & coordY(p)==Y & coordZ(p)==Z
						
						EXISTEnodo=1;
						NUMnodo=p;
					else
						
						p=p+1;
					end;
				end;
				
				if EXISTEnodo==1
					C(h)=NUMnodo;
				else
					coordX(PUNTO)=X;
					coordY(PUNTO)=Y;
					coordZ(PUNTO)=Z;
					C(h)=PUNTO;
					PUNTO=PUNTO+1;
				end;
			end;

               
            for q=1:8
                
                D(CUBO,q)=C(q);
                
            end;
            
%Creacin de aristas

			for COLUMNAarista=1:12
				
				pos1=COLUMNAarista;
				pos2=COLUMNAarista+1;
				
				if pos2==5
					pos2=1;
				end;
				
				if pos2==9
					pos2=5;
				end;
				
				if COLUMNAarista>8
					pos1=COLUMNAarista-8;
					pos2=pos1+4;
				end;
                    
                    a=double(C(pos1));
                    b=double(C(pos2));
                    
				if a > b
					auxiliar=pos1;
					pos1=pos2;
					pos2=auxiliar;
				end;
                
                a=C(pos1);
                b=C(pos2);

				EXISTEarista=0;
				s=1;
				
				while s<ARISTA & EXISTEarista==0

					if B(1,s)==C(pos1) & B(2,s)==C(pos2)

						EXISTEarista=1;
						NUMarista=s;
					else
						s=s+1;
					end;
				end;
				
				if EXISTEarista==1
					A(CUBO,COLUMNAarista)=NUMarista;
					
				else
					A(CUBO,COLUMNAarista)=ARISTA;
					B(1,ARISTA)=C(pos1);
                    B(2,ARISTA)=C(pos2);
                    
                    UNO=subs(a);
                    DOS=subs(b);
                    
                    %Dibujar cada arista en el momento que se crea%
                    DibujarX(1)=coordX(UNO);
                    DibujarX(2)=coordX(DOS);
                    DibujarY(1)=coordY(UNO);
                    DibujarY(2)=coordY(DOS);
                    DibujarZ(1)=coordZ(UNO);
                    DibujarZ(2)=coordZ(DOS);
                   
                    plot3(DibujarX,DibujarY,DibujarZ);
                    hold on;
                                       
					ARISTA=ARISTA+1;
				end;
			end;

		end;
	end;
end;


%CREACION DEL FICHERO CON TODAS LAS RELACIONES ENTRE NODOS,ARISTAS Y CUBOS%

 fprintf(1,'Escriba el nombre del fichero de la forma - disco:\\nombre.ext\n');
 fprintf(1,'Por ejemplo:  A:\\OUTPUT.DTA\n');
 NAME = input(' ','s');
 OUP = fopen(NAME,'wt');
 fprintf(OUP, 'MALLA HEXAEDRICA - Progresion aritmetica\n\n');
 %Matriz A%
 fprintf(OUP, 'Matriz A relaciona cada CUBO con el nombre de sus 12 ARISTAS \n\n');
 fprintf(OUP, 'CUBO  ARISTAS\n\n');
 for I = 1 : CUBO 
 fprintf(OUP, ' %3d  ', I);
 for J = 1 : 12 
 fprintf(OUP, '  %3d', subs(A(I,J)));
 end;
 fprintf(OUP, '\n');
 end;
 
 fprintf(OUP, '\n\n\n');
 
 %Matriz D%
 fprintf(OUP, 'Matriz D relaciona cada CUBO con el nombre de sus 8 NODOS \n\n');
 fprintf(OUP, 'CUBO  NODOS\n\n');
 for I = 1 : CUBO 
 fprintf(OUP, ' %3d  ', I);
 for J = 1 : 8 
 fprintf(OUP, '  %3d', subs(D(I,J)));
 end;
 fprintf(OUP, '\n');
 end;
 
 fprintf(OUP, '\n\n\n');
 
 %Matriz B%
 fprintf(OUP, 'Matriz B relaciona cada ARISTA con el nombre de sus 2 NODOS \n\n');
 fprintf(OUP, 'ARISTA  NODOS\n\n');
 for I = 1 :  (ARISTA-1)
 fprintf(OUP, ' %3d  ', I);
 for J = 1 : 2 
 fprintf(OUP, '  %3d', subs(B(J,I)));
 end;
 fprintf(OUP, '\n');
 end;
 
 fprintf(OUP, '\n\n\n');
 
 %Vectores de coordenadas%
 fprintf(OUP, 'Relacion de cada NODO con el valor de sus 3 COORDENADAS \n\n');
 fprintf(OUP, 'NODO    COORD X        COORD Y        COORD Z\n\n');
 for I = 1 :  (PUNTO-1)
 fprintf(OUP, ' %3d  ', I);
  
 fprintf(OUP, '%12.8f   %12.8f   %12.8f', coordX(I),coordY(I),coordZ(I));
 
 fprintf(OUP, '\n');
 end;
 
 fclose(OUP);
    
end;

%ESTRATEGIA 6%
if FLAG==6

    %Introduccion de datos%
    
    fprintf(1,'\nHa seleccionado la ESTRATEGIA 6\n\n'); 
fprintf(1,'Introduzca el numero de puntos en la direccion x\n');
NumPuntosx = input(' ');
fprintf(1,'Introduzca el numero de puntos en la direccion y\n');
NumPuntosy = input(' ');
fprintf(1,'Introduzca el numero de puntos en la direccion z\n');
NumPuntosz = input(' ');

NUMz=NumPuntosz-1;
NUMy=NumPuntosy-1;
NUMx=NumPuntosx-1;
deltaX=1/NUMx;
deltaY=1/NUMy;

SUMA=2;
h1=(1/NUMz);

%Bucle de eleccion de incremento vertical inicial%

while abs(SUMA-1)>1e-6
    
    if (SUMA-1)>0
        h1=0.999*h1;
    else
        h1=1.001*h1;
    end;
        
    hprevio=h1;  
    SUMA=h1;
    
    %Bucle de calculo del incremento%
    
    for nivel=2:NUMz
        
        hnivel=hprevio+h1*hprevio;
        SUMA=SUMA+hnivel;
        hprevio=hnivel;
    end;
end;
    
    hnivel=h1;

    %Bucle de generacion de hexaedros%
    
for k=1:NUMz
    
    if k==1
        Z0=0;
        deltaZ=h1;
    else
    
	Z0=Z0+hnivel;
    hnivel=hnivel+h1*hnivel;
    deltaZ=hnivel;
    end;
    
	for j=1:NUMy
		Y0=(j-1)*deltaY;
		
		for i=1:NUMx
			X0=(i-1)*deltaX;
			CUBO=CUBO+1;

			for r=1:8
			C(r)=0;
			end;

			for h=1:8
				
				X=X0+u(h)*deltaX;
				Y=Y0+v(h)*deltaY;
				Z=Z0+w(h)*deltaZ;
				
				EXISTEnodo=0;
				p=1;

				while p<PUNTO & EXISTEnodo==0

					if coordX(p)==X & coordY(p)==Y & coordZ(p)==Z
						
						EXISTEnodo=1;
						NUMnodo=p;
					else
						
						p=p+1;
					end;
				end;
				
				if EXISTEnodo==1
					C(h)=NUMnodo;
				else
					coordX(PUNTO)=X;
					coordY(PUNTO)=Y;
					coordZ(PUNTO)=Z;
					C(h)=PUNTO;
					PUNTO=PUNTO+1;
				end;
			end;

               
            for q=1:8
                
                D(CUBO,q)=C(q);
                
            end;
            
%Creacin de aristas

			for COLUMNAarista=1:12
				
				pos1=COLUMNAarista;
				pos2=COLUMNAarista+1;
				
				if pos2==5
					pos2=1;
				end;
				
				if pos2==9
					pos2=5;
				end;
				
				if COLUMNAarista>8
					pos1=COLUMNAarista-8;
					pos2=pos1+4;
				end;
                    
                    a=double(C(pos1));
                    b=double(C(pos2));
                    
				if a > b
					auxiliar=pos1;
					pos1=pos2;
					pos2=auxiliar;
				end;
                
                a=C(pos1);
                b=C(pos2);

				EXISTEarista=0;
				s=1;
				
				while s<ARISTA & EXISTEarista==0

					if B(1,s)==C(pos1) & B(2,s)==C(pos2)

						EXISTEarista=1;
						NUMarista=s;
					else
						s=s+1;
					end;
				end;
				
				if EXISTEarista==1
					A(CUBO,COLUMNAarista)=NUMarista;
					
				else
					A(CUBO,COLUMNAarista)=ARISTA;
					B(1,ARISTA)=C(pos1);
                    B(2,ARISTA)=C(pos2);
                    
                    UNO=subs(a);
                    DOS=subs(b);
                    
                    %Dibujar cada arista en el momento que se crea%
                    DibujarX(1)=coordX(UNO);
                    DibujarX(2)=coordX(DOS);
                    DibujarY(1)=coordY(UNO);
                    DibujarY(2)=coordY(DOS);
                    DibujarZ(1)=coordZ(UNO);
                    DibujarZ(2)=coordZ(DOS);
                   
                    plot3(DibujarX,DibujarY,DibujarZ);
                    hold on;
                                       
					ARISTA=ARISTA+1;
				end;
			end;

		end;
	end;
end;


%CREACION DEL FICHERO CON TODAS LAS RELACIONES ENTRE NODOS,ARISTAS Y CUBOS%

 fprintf(1,'Escriba el nombre del fichero de la forma - disco:\\nombre.ext\n');
 fprintf(1,'Por ejemplo:  A:\\OUTPUT.DTA\n');
 NAME = input(' ','s');
 OUP = fopen(NAME,'wt');
 fprintf(OUP, 'MALLA HEXAEDRICA - Progresion geometrica\n\n');
 %Matriz A%
 fprintf(OUP, 'Matriz A relaciona cada CUBO con el nombre de sus 12 ARISTAS \n\n');
 fprintf(OUP, 'CUBO  ARISTAS\n\n');
 for I = 1 : CUBO 
 fprintf(OUP, ' %3d  ', I);
 for J = 1 : 12 
 fprintf(OUP, '  %3d', subs(A(I,J)));
 end;
 fprintf(OUP, '\n');
 end;
 
 fprintf(OUP, '\n\n\n');
 
 %Matriz D%
 fprintf(OUP, 'Matriz D relaciona cada CUBO con el nombre de sus 8 NODOS \n\n');
 fprintf(OUP, 'CUBO  NODOS\n\n');
 for I = 1 : CUBO 
 fprintf(OUP, ' %3d  ', I);
 for J = 1 : 8 
 fprintf(OUP, '  %3d', subs(D(I,J)));
 end;
 fprintf(OUP, '\n');
 end;
 
 fprintf(OUP, '\n\n\n');
 
 %Matriz B%
 fprintf(OUP, 'Matriz B relaciona cada ARISTA con el nombre de sus 2 NODOS \n\n');
 fprintf(OUP, 'ARISTA  NODOS\n\n');
 for I = 1 :  (ARISTA-1)
 fprintf(OUP, ' %3d  ', I);
 for J = 1 : 2 
 fprintf(OUP, '  %3d', subs(B(J,I)));
 end;
 fprintf(OUP, '\n');
 end;
 
 fprintf(OUP, '\n\n\n');
 
 %Vectores de coordenadas%
 fprintf(OUP, 'Relacion de cada NODO con el valor de sus 3 COORDENADAS \n\n');
 fprintf(OUP, 'NODO    COORD X        COORD Y        COORD Z\n\n');
 for I = 1 :  (PUNTO-1)
 fprintf(OUP, ' %3d  ', I);
  
 fprintf(OUP, '%12.8f   %12.8f   %12.8f', coordX(I),coordY(I),coordZ(I));
 
 fprintf(OUP, '\n');
 end;
 
 fclose(OUP);
    
end;

%ESTRATEGIA 7%

if FLAG==7

    %Introduccion de datos%
    
fprintf(1,'Introduzca el numero de puntos en la direccion x\n');
NumPuntosx = input(' ');
fprintf(1,'Introduzca el numero de puntos en la direccion y\n');
NumPuntosy = input(' ');
fprintf(1,'Introduzca el numero de puntos en la direccion z\n');
NumPuntosz = input(' ');

NUMz=NumPuntosz-1;
NUMy=NumPuntosy-1;
NUMx=NumPuntosx-1;
deltaX=1/NUMx;
deltaY=1/NUMy;

SUMA=2;
h1=(1/NUMz);

%Bucle de eleccion de incremento vertical inicial%

while abs(SUMA-1)>1e-6
    
    if (SUMA-1)>0
        h1=0.999*h1;
    else
        h1=1.001*h1;
    end;
        
    hprevio=h1;  
    SUMA=h1;
    
    %Bucle de calculo del incremento%
    
    for nivel=2:NUMz
        
        hnivel=hprevio+hprevio^2;
        SUMA=SUMA+hnivel;
        hprevio=hnivel;
    end;
end;
    
    hnivel=h1;

    %Bucle de generacion de hexaedros%
    
for k=1:NUMz
    
    if k==1
        Z0=0;
        deltaZ=h1;
    else
    
	Z0=Z0+hnivel;
    hnivel=hnivel+hnivel^2;
    deltaZ=hnivel;
    end;
    
	for j=1:NUMy
		Y0=(j-1)*deltaY;
		
		for i=1:NUMx
			X0=(i-1)*deltaX;
			CUBO=CUBO+1;

			for r=1:8
			C(r)=0;
			end;

			for h=1:8
				
				X=X0+u(h)*deltaX;
				Y=Y0+v(h)*deltaY;
				Z=Z0+w(h)*deltaZ;
				
				EXISTEnodo=0;
				p=1;

				while p<PUNTO & EXISTEnodo==0

					if coordX(p)==X & coordY(p)==Y & coordZ(p)==Z
						
						EXISTEnodo=1;
						NUMnodo=p;
					else
						
						p=p+1;
					end;
				end;
				
				if EXISTEnodo==1
					C(h)=NUMnodo;
				else
					coordX(PUNTO)=X;
					coordY(PUNTO)=Y;
					coordZ(PUNTO)=Z;
					C(h)=PUNTO;
					PUNTO=PUNTO+1;
				end;
			end;

               
            for q=1:8
                
                D(CUBO,q)=C(q);
                
            end;
            
%Creacin de aristas

			for COLUMNAarista=1:12
				
				pos1=COLUMNAarista;
				pos2=COLUMNAarista+1;
				
				if pos2==5
					pos2=1;
				end;
				
				if pos2==9
					pos2=5;
				end;
				
				if COLUMNAarista>8
					pos1=COLUMNAarista-8;
					pos2=pos1+4;
				end;
                    
                    a=double(C(pos1));
                    b=double(C(pos2));
                    
				if a > b
					auxiliar=pos1;
					pos1=pos2;
					pos2=auxiliar;
				end;
                
                a=C(pos1);
                b=C(pos2);

				EXISTEarista=0;
				s=1;
				
				while s<ARISTA & EXISTEarista==0

					if B(1,s)==C(pos1) & B(2,s)==C(pos2)

						EXISTEarista=1;
						NUMarista=s;
					else
						s=s+1;
					end;
				end;
				
				if EXISTEarista==1
					A(CUBO,COLUMNAarista)=NUMarista;
					
				else
					A(CUBO,COLUMNAarista)=ARISTA;
					B(1,ARISTA)=C(pos1);
                    B(2,ARISTA)=C(pos2);
                    
                    UNO=subs(a);
                    DOS=subs(b);
                    
                    %Dibujar cada arista en el momento que se crea%
                    DibujarX(1)=coordX(UNO);
                    DibujarX(2)=coordX(DOS);
                    DibujarY(1)=coordY(UNO);
                    DibujarY(2)=coordY(DOS);
                    DibujarZ(1)=coordZ(UNO);
                    DibujarZ(2)=coordZ(DOS);
                   
                    plot3(DibujarX,DibujarY,DibujarZ);
                    hold on;
                                       
					ARISTA=ARISTA+1;
				end;
			end;

		end;
	end;
end;


%CREACION DEL FICHERO CON TODAS LAS RELACIONES ENTRE NODOS,ARISTAS Y CUBOS%

 fprintf(1,'Escriba el nombre del fichero de la forma - disco:\\nombre.ext\n');
 fprintf(1,'Por ejemplo:  A:\\OUTPUT.DTA\n');
 NAME = input(' ','s');
 OUP = fopen(NAME,'wt');
 fprintf(OUP, 'MALLA HEXAEDRICA - Concentracion en la zona inferior manteniendo esquemas de segundo orden\n\n');
 %Matriz A%
 fprintf(OUP, 'Matriz A relaciona cada CUBO con el nombre de sus 12 ARISTAS \n\n');
 fprintf(OUP, 'CUBO  ARISTAS\n\n');
 for I = 1 : CUBO 
 fprintf(OUP, ' %3d  ', I);
 for J = 1 : 12 
 fprintf(OUP, '  %3d', subs(A(I,J)));
 end;
 fprintf(OUP, '\n');
 end;
 
 fprintf(OUP, '\n\n\n');
 
 %Matriz D%
 fprintf(OUP, 'Matriz D relaciona cada CUBO con el nombre de sus 8 NODOS \n\n');
 fprintf(OUP, 'CUBO  NODOS\n\n');
 for I = 1 : CUBO 
 fprintf(OUP, ' %3d  ', I);
 for J = 1 : 8 
 fprintf(OUP, '  %3d', subs(D(I,J)));
 end;
 fprintf(OUP, '\n');
 end;
 
 fprintf(OUP, '\n\n\n');
 
 %Matriz B%
 fprintf(OUP, 'Matriz B relaciona cada ARISTA con el nombre de sus 2 NODOS \n\n');
 fprintf(OUP, 'ARISTA  NODOS\n\n');
 for I = 1 :  (ARISTA-1)
 fprintf(OUP, ' %3d  ', I);
 for J = 1 : 2 
 fprintf(OUP, '  %3d', subs(B(J,I)));
 end;
 fprintf(OUP, '\n');
 end;
 
 fprintf(OUP, '\n\n\n');
 
 %Vectores de coordenadas%
 fprintf(OUP, 'Relacion de cada NODO con el valor de sus 3 COORDENADAS \n\n');
 fprintf(OUP, 'NODO    COORD X        COORD Y        COORD Z\n\n');
 for I = 1 :  (PUNTO-1)
 fprintf(OUP, ' %3d  ', I);
  
 fprintf(OUP, '%12.8f   %12.8f   %12.8f', coordX(I),coordY(I),coordZ(I));
 
 fprintf(OUP, '\n');
 end;
 
 fclose(OUP);
					
end;
 


